SystemOrganization addCategory: #'GBT-DSL_SEU'!

Object subclass: #GbtSdeCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_SEU'!

!GbtSdeCompiler class methodsFor: 'example' stamp: 'hk 1/10/2018 13:44'!
exampleClearStore
	GbtServer clearStore: #SDE
! !

!GbtSdeCompiler class methodsFor: 'example' stamp: 'hk 1/13/2018 17:43'!
exampleRun
	GbtServer initialize: #SDE.
	(self new 
		ensureCompilation; 
		sdeCompilerAC ) ui 
			title: 'AnyThing SDE'; 
			open! !

!GbtSdeCompiler methodsFor: 'contexts' stamp: 'hk 2/8/2018 21:26'!
contextCompilerContexts
	^ '
	uList ContextsCompilerAC of GbtContextSource {  
	 	displayAs 	: 	Contexts
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIconCtxt16
		listPrefix 	: 	C 
		subcontext 	: 	ContextCompilerAC 
		menu 			:  reverse 
		menu 			:  allReverse
		behaviors 	:  oneReverse reverse allReverse getContexts oneBehReverse
		elderSlot	: contexts
		}
	lazy behavior getContexts { 
		vo 		 		: contextThing(EditAC)
		appName		: vo:bizAppName
		all 		 	: gbt ( ''GbtServer appContextsOf:'' appName)
	}
	lazy behavior reverse { 
		contexts 		: apply(getContexts)
		context 		: askUser ( ''Welcher Context?'' contexts)
		reverse 		: apply(oneReverse context)
	}
	lazy behavior allReverse { 
		contexts 		: apply(getContexts.all)
		allReverse 	: applyOnList (oneReverse contexts)
	}
	behavior oneReverse 
		arg1 			: % the input context
		{ 
		newSource		: newContextThing(ContextCompilerAC)
		newSource1 	: pasteOnto(SourceCopier arg1 newSource)
		behaviors 	: arg1:behaviorColl
		oneReverse 	: applyOnList (oneBehReverse behaviors) % newSource1 needed when lazy
	}
	lazy behavior oneBehReverse  
		arg1 			: % the input behavior - also list arg
		{
		newSource		: newContextThing(BehaviorCompilerAC)
		res 			: pasteOnto(SourceCopier arg1 newSource)
	}

	plain ContextCompilerAC {  
	 	displayAs 	: 	Context
		uiSpec 		: 	GbtItemWithTabsUI
		icon 			: 	GbtIconCtxt16
		subcontexts 	: 	BehaviorsCompilerAC 
		}
	uList BehaviorsCompilerAC of GbtSource {  
	 	displayAs 	: 	Behaviors
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIconBeh16
		listPrefix 	: 	B 
		subcontext 	: 	BehaviorCompilerAC 
		elderSlot	: behaviors
		}
	plain BehaviorCompilerAC {  
	 	displayAs 	: 	Behavior
		uiSpec 		: 	GbtItemUI
		icon 			: 	GbtIconBeh16
		}
			'! !

!GbtSdeCompiler methodsFor: 'compile' stamp: 'hk 1/27/2018 16:50'!
ensureCompilation
	"sort of incremental ..."  
	| compiler |
	compiler := GbtCompiler new.
	{self things . self projectors . self topContexts . self thingCompilerContexts . self projCompilerContexts . self contextCompilerContexts . self testEnvContexts } 
		do: [:sources | compiler parse: sources onError: [ :msg :pos | self error: msg, ' at: ', pos printString ]]! !

!GbtSdeCompiler methodsFor: 'contexts' stamp: 'hk 1/29/2018 14:16'!
projCompilerContexts
	^ '
	uList ProjectorsCompilerAC of GbtSource {  
	 	displayAs 	: 	Projectors
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIconThing16
		listPrefix 	: 	P
		subcontext 	: 	ProjectorCompilerAC 
		menu 			:  reverse 
		menu 			:  allReverse
		behaviors 	:  oneReverse reverse allReverse getProjs
		elderSlot	 	: projectors
		}
	behavior getProjs { 
		vo 		 		: contextThing(EditAC)
		appName		: vo:bizAppName
		getProjs 		: gbt ( ''GbtServer appProjectorsOf:'' appName)
	}
	behavior reverse { 
		projs  		: apply(getProjs)
		proj 			: askUser ( ''Welcher Projektor?'' projs)
		reverse 		: apply(oneReverse proj)
	}
	behavior allReverse { 
		projs 			: apply(getProjs)
		allReverse 	: applyOnList (oneReverse projs)
	}
	behavior oneReverse 
		input 			: % the input thing
		{ 
		newSource		: newContextThing(ProjectorCompilerAC)
		oneReverse 	: pasteOnto(SourceCopier input newSource)
	}

	plain ProjectorCompilerAC {  
	 	displayAs 	: 	SDE
		uiSpec 		: 	GbtItemUI
		icon 			: 	GbtIconThing16
		}
'! !

!GbtSdeCompiler methodsFor: 'functions' stamp: 'hk 1/28/2018 14:18'!
projectors
	^'	
	projector SourceCopier  {
		tag svoName 		: sourceName 
		tag gbtSource 	: source  
	}
	'! !

!GbtSdeCompiler methodsFor: 'compile' stamp: 'hk 1/27/2018 16:37'!
sdeCompilerAC 
	^GbtSmartContext definedAs: 'SdeCompilerAC' ! !

!GbtSdeCompiler methodsFor: 'contexts' stamp: 'hk 1/13/2018 17:46'!
testEnvContexts
	^ '	
	uList TestThingsAC of GbtSource {  
	 	displayAs 	: 	Things
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIconThing16
		listPrefix 	: 	T 
		subcontext 	: 	TestThingAC 
		elderSlot	: things
		}
	plain TestThingAC {  
	 	displayAs 	: 	Thing
		uiSpec 		: 	GbtItemUI
		icon 			: 	GbtIconThing16
		}
	uList TestProjectorsAC of GbtSource {  
	 	displayAs 	: 	Projectors
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIconThing16
		listPrefix 	: 	P
		subcontext 	: 	TestProjectorAC 
		elderSlot	: projectors
		}
	plain TestProjectorAC {  
	 	displayAs 	: 	Projector
		uiSpec 		: 	GbtItemUI
		icon 			: 	GbtIconThing16
		}

	'! !

!GbtSdeCompiler methodsFor: 'contexts' stamp: 'hk 1/29/2018 14:04'!
thingCompilerContexts
	^ '

	uList ThingsCompilerAC of GbtSource {  
	 	displayAs 	: 	Things
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIconThing16
		listPrefix 	: 	T 
		subcontext 	: 	ThingCompilerAC 
		menu 			:  reverse 
		menu 			:  allReverse
		behaviors 	:  oneReverse reverse allReverse getThings
		elderSlot	: things
		}
	behavior getThings { 
		vo 		 		: contextThing(EditAC)
		appName		: vo:bizAppName
		getThings 	: gbt ( ''GbtServer appThingsOf:'' appName)
	}
	behavior reverse { 
		things 		: apply(ThingsCompilerAC:getThings)
		thing 			: askUser ( ''Welches Thing?'' things)
		reverse 		: apply(oneReverse thing)
	}
	behavior allReverse { 
		things 		: apply(getThings)
		allReverse 	: applyOnList (oneReverse things)
	}
	behavior oneReverse  
		inputThing 	: 
		{
		newSource		: newContextThing(ThingCompilerAC)
		oneReverse 	: pasteOnto(SourceCopier inputThing newSource)
	}

	plain ThingCompilerAC {  
	 	displayAs 	: 	SDE
		uiSpec 		: 	GbtItemUI
		icon 			: 	GbtIconThing16
		}
	'! !

!GbtSdeCompiler methodsFor: 'things' stamp: 'hk 1/24/2018 16:33'!
things
^'	thing AppSource 
		summary 						:  #bizAppName #shortDescription
		{ 
		*val bizAppName				:
		*val shortDescription 	:
		*text 	longDescription		:  
		*list things 				:  GbtSource 
		*list projectors 			:  GbtSource 
		*list contexts 				:  GbtSource
		}
	thing GbtSource 
		summary 						:  #sourceName
		ui 								:  GbtSourceWidget
		{ 
		*val sourceName 			:
		*text	source 				:  
		}	
	thing GbtContextSource 
		summary 						:  #sourceName
		ui 								:  GbtSourceWidget
		{ 
		*val sourceName 			:
		*text	source 				:  
		*list behaviors 			:  GbtSource
		}	
	thing AppTestData 
		{ 
		*val bizApp 					:
		*val shortDescription 	:
		*text 	longDescription		:  
		*list things 				:  GbtSource 
		*list projectors 			:  GbtSource 
		}
'
! !

!GbtSdeCompiler methodsFor: 'contexts' stamp: 'hk 1/29/2018 14:02'!
topContexts
	^ '
	plain SdeCompilerAC { 
		subcontexts 	: 	ApplicationsEditAC  ApplicationsTestAC
		uiSpec 		: 	GbtMainUI 
		icon 			: 	GbtIcon96
		windowSize 	: 	1200 @ 900
		legalText 	: 	GloConn International © 2018
		}
	primeList ApplicationsEditAC of AppSource {  
	 	displayAs 	: 	Anything Editor
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	GbtIcon16
		loadPolicy 	: 	autoload 
		listPrefix 	: 	App 
		subcontext 	:  EditAC
		menu 			:  NewFromApp
		behaviors 	:  NewFromApp
		}
	behavior NewFromApp { 
		appList 		: gbt ( ''GbtServer instanceNames'' )
		selectedApp 	: askUser ( ''Welche App?'' appList)
		newSource 	: newContextThing (EditAC)
		NewFromApp 	: newSource:bizAppName := selectedApp
	}
	primeList ApplicationsTestAC of AppTestData {
	 	displayAs 	: 	Anything TestData
		uiSpec 		: 	GbtListAndItemUI 
		icon 			: 	GbtIconTest16
		listPrefix 	: 	AppTD 
		subcontext 	:  TestAC
		}
	plain EditAC on AppSource {
	 	displayAs 	: 	Anything Source
		subcontexts 	: 	ThingsCompilerAC ProjectorsCompilerAC ContextsCompilerAC 
		pool 			:  SourceCopier
		uiSpec 		: 	GbtItemWithTabsUI 
		icon 			: 	GbtIconEdit16
		}
	plain TestAC on AppTestData {
	 	displayAs 	: 	Anything TestData
		subcontexts 	: 	TestThingsAC TestProjectorsAC 
		uiSpec 		: 	GbtItemWithTabsUI 
		icon 			: 	GbtIconTest16
		} '! !

Object subclass: #GbtSdeTester
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_SEU'!
